

#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerWave;
uniform int texWidth, texHeight;
uniform float sizeX, sizeY;
uniform float height;//ʂ̍

uniform float nRatio;
uniform int flagInverse;

varying vec4 refCoord;
varying vec3 P;
varying vec3 N;

vec3 calcRefract(vec3 I, vec3 N, float nRatio, int flagInverse);

void main(void)
{	
	vec3 T;//ڐxNg
	vec3 B;//]@xNg
	vec2 grad;

	//eNX`W̒Sړ
	vec2 texPos = gl_Vertex.xy + vec2(float(texWidth/2), float(texHeight/2));
	
	float p1, p2;
	float delta = 0.1;//Ԋu
	float pp = texture2DRect(samplerWave, texPos).b;//ꂽψʗ
	pp = clamp(pp, -0.5, 0.5);

	//z
	p1 = texture2DRect(samplerWave, texPos + vec2(-delta, 0.0)).b;
	p2 = texture2DRect(samplerWave, texPos + vec2( delta, 0.0)).b;
	grad.x = (p2 - p1) / (2.0 * delta);//x
	p1 = texture2DRect(samplerWave, texPos + vec2(0.0, -delta)).b;
	p2 = texture2DRect(samplerWave, texPos + vec2(0.0,  delta)).b;
	grad.y = (p2 - p1) / (2.0 * delta);//y

	//ӂ̒sizeX,sizeYɕϊ
 	gl_Vertex.x *= sizeX /  float(texWidth-1);
	gl_Vertex.y *= sizeY /  float(texHeight-1);

	gl_Vertex.z = height + pp;//(\̍𒲐j

	P = vec3(gl_ModelViewMatrix * gl_Vertex);
	N = normalize(gl_NormalMatrix * gl_Normal).xyz;
	//ڐxNg
	T = normalize(gl_NormalMatrix * vec3(1.0, 0.0, 0.0)).xyz;
	//]@xNg
	B = normalize(gl_NormalMatrix * vec3(0.0, 1.0, 0.0)).xyz;
	//V@xNg
	N = normalize(N - grad.x * T - grad.y * B);

	//܃xNǧvZ
	vec3 incident = normalize(P);//˃xNg
	vec3 TT = calcRefract(incident, N, nRatio, flagInverse) ;//̋܃xNg	
	refCoord = gl_ModelViewMatrixTranspose * vec4(TT, 0.0) ;//܃xNgɂeNX`W
 
	gl_Position = ftransform();
}

//------------------------------------------------------------------------------
vec3 calcRefract(vec3 I, vec3 N, float nRatio, int flagInverse)
{//܃xNǧvZ

	if(flagInverse == 1){//_ʈȉ
		N = - N;
		nRatio = 1.0 / nRatio;
	}
	float cosIN = - dot(I, N);
	float a = nRatio * nRatio - 1.0 + cosIN * cosIN;
	if(a < 0.0) return reflect(I, N);//S
	else return (I - N *(sqrt(a) - cosIN)) / nRatio;
}
